package cz.vse.xkucf03.emailBrana;
/*
 * Brana.java
 *
 * Created on 3. prosinec 2005, 22:08
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */


import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;
import java.util.Properties;
import javax.mail.Authenticator;
import javax.mail.BodyPart;
import javax.mail.Flags.Flag;
import javax.mail.Folder;
import javax.mail.Message;
import javax.mail.PasswordAuthentication;
import javax.mail.Session;
import javax.mail.Store;
import javax.mail.Transport;
import javax.mail.internet.InternetAddress;
import javax.mail.internet.MimeBodyPart;
import javax.mail.internet.MimeMessage;
import javax.mail.internet.MimeMultipart;

/**
 *
 * @author fiki
 */
public class Brana {
    
    //Konfigurace brány
    private static long intervalKontroly = 60000;    // jak často se budou kontrolovat nové požadavky (v milisekundách)
    private String imapServer = "imap.atlas.cz";    // odkud se budou stahovat požadavky
    private String imapUzivatel = "";	    // jméno k imap serveru
    private String imapHeslo = "";	    // heslo k imap serveru
    private String smtpServer = "smtp.volny.cz";    // odchozí smtp server
    private String smtpOdesilatel = ""; // adresa brány
    private String systemHeslo = "test";	    //heslo pro zadávání systémových příkazů pomocí emailů - ZMĚNIT!!!
    //Konec konfigurace brány
    
    
    
    
    
    
    
    private int pocitadloCyklu = 0;
    private int pocitadloOdeslanychZprav = 0;
    private Session smtpSession;
    private Session imapSession;
    private Store imapStore;
    private Folder imapSlozka;
    
    /** Creates a new instance of Brana */
    public Brana() {
	
	Properties props = System.getProperties();
	props.put("mail.smtp.host", smtpServer);
	Authenticator auth = new PopUpAuthenticator();
	smtpSession = Session.getInstance(props, auth);
	
	
	
	
	
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
	final Brana brana = new Brana();
	
	// bude to běhat pořád dokola
	Thread vlakno = new Thread() {
	    public void run() {
		while(true) {
		    brana.zkontroluj();
		    
		    
		    try {
			Thread.sleep(intervalKontroly);
		    } catch (InterruptedException e) {
			e.printStackTrace();
		    }		    
		}
	    }
	};
	vlakno.start();
    }
    
    public void zkontroluj() {
	pocitadloCyklu++;
	
	System.out.println("Kontrola číslo: " + pocitadloCyklu);
	
	
	try {
	    
	    Properties propsImap = new Properties();
	    imapSession = Session.getDefaultInstance(propsImap, null);
	    
	    imapStore = imapSession.getStore("imap");
	    imapStore.connect(imapServer, imapUzivatel, imapHeslo);
	    imapSlozka = imapStore.getFolder("INBOX");
	    imapSlozka.open(Folder.READ_WRITE);
	    
	    Message message[] = imapSlozka.getMessages();
	    
	    for (int i=0, n=message.length; i<n; i++) {
		
		if (!message[i].getFlags().contains(Flag.SEEN)) {
		    message[i].setFlag(Flag.SEEN, true);
		    if (message[i].getSubject().startsWith("system-" + systemHeslo +"-")) {
			provedSystemovyPrikaz(message[i].getSubject(), message[i].getFrom()[0].toString());
		    } else {
			odesliStranku(message[i].getFrom()[0].toString(), message[i].getSubject());
		    }
		}
		
	    }
	    
	    imapSlozka.close(true);
	    imapStore.close();	    
	    
	} catch (Exception e) {
	    e.printStackTrace();
	}
	
    }
    
    public void odesliStranku(String komu, String url) {
	
	try {
	    MimeMessage message = new MimeMessage(smtpSession);
	    message.setFrom(new InternetAddress(smtpOdesilatel));
	    message.addRecipient(Message.RecipientType.TO,
	    new InternetAddress(komu));
	    message.setSubject("WEB-MAIL Brána: " + url);
	    
	    
	    URL cesta = new URL(url);
	    
	    StringBuffer stranka = new StringBuffer();
	    Object obsah = cesta.getContent();
	    
	    BufferedReader in = new BufferedReader(
	    new InputStreamReader(
	    cesta.openStream()));
	    
	    String inputLine;
	    
	    while ((inputLine = in.readLine()) != null) {
		stranka.append(inputLine);
		//System.out.println(inputLine); // zobrazuje staženou stránku
	    }
	    in.close();
	    
	    
	    BodyPart messageBodyPart = new MimeBodyPart();
	    String htmlText = stranka.toString();
	    messageBodyPart.setContent(htmlText, "text/html");
	    
	    MimeMultipart multipart = new MimeMultipart("related");
	    multipart.addBodyPart(messageBodyPart);
	    
	    message.setContent(multipart);
	    
	    Transport.send(message);
	    pocitadloOdeslanychZprav++;
	    System.out.println("Odesílám stránku: " + pocitadloOdeslanychZprav + " - " + url);
	    
	} catch (Exception e) {
	    
	    //odešleme nápovědu:
	    odesliZpravu(komu, "WEB-MAIL Brána: Nápověda", "Toto je jednoduchá brána mezi protokoly SMTP a HTTP \n" +
	    "Slouží těm, kteří mají jen emailový program a nemají přístup k HTTP\n" +
	    "Brána se používá takto:\n" +
	    "-odešlěte mail na adresu " + smtpOdesilatel + " s předmětem http://www.server.tld \n" +
	    "-během několika vteřin* dostanete zpět email obsahující požadovanou stránku \n" +
	    "(tu, kterou jste zadali do předmětu)\n\n" +
	    "Pozor: do předmětu musíte zadat adresu včetně protokolu http://\n" +
	    "Pokud zadáte cokoli jiného, než platné URL, dostanete tuto nápovědu\n\n" +
	    "Vaše WEB-Mail Brána: " + smtpOdesilatel + 
	    "\n\n\n*) kéž by tomu tak bylo - bohužel závisí i na příchozím a odchozím serveru, které mohou zprávy zdržet");
	    
	}
	
    }
    
    public void provedSystemovyPrikaz(String prikaz, String od) {
	if (prikaz.startsWith("system-" + systemHeslo +"-konec")) {
	    System.out.println("Ukončuji činnost brány na základě emailu od: " + od);
	    odesliZpravu(od, "WEB-MAIL Brána: Systém - Konec", "Ukončuji provoz brány na základě vašeho (" + od +") požadavku");
	    
	    try {
		imapSlozka.close(true);
		imapStore.close();
		System.exit(0);
	    } catch (Exception e) {
		e.printStackTrace();
	    }
	    
	}
	
    }
    
    public void odesliZpravu(String komu, String predmet, String text) {
	
	
	
	try {
	    MimeMessage message = new MimeMessage(smtpSession);
	    message.setFrom(new InternetAddress(smtpOdesilatel));
	    message.addRecipient(Message.RecipientType.TO,
	    new InternetAddress(komu));
	    message.setSubject(predmet);
	    message.setText(text);
	    
	    System.out.println("Odesílám zprávu: " + pocitadloOdeslanychZprav + " (" + predmet + ") pro: " + komu);
	    Transport.send(message);
	    
	} catch (Exception e) {
	    
	    e.printStackTrace();
	}
	
    }
    
}

class PopUpAuthenticator extends Authenticator {
    
    public PasswordAuthentication getPasswordAuthentication() {
	return new PasswordAuthentication("user", "luser");
    }
    
}
